#####################################################################################
#
#	:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]:::
#				 ___                 _
#				| __| __ _  __ _  __| | _ _  ___  _ __
#				| _| / _` |/ _` |/ _` || '_|/ _ \| '_ \
#				|___|\__, |\__, |\__,_||_|  \___/| .__/
#				     |___/ |___/                 |_|
#
#####################################################################################
#
# phrase.tcl v0.1
#
#     http://icmp.ru/phraser/
#
#####################################################################################
# 
# : 1)     scripts
#			 2)  eggdrop.conf  source scripts/phrase.tcl
#
# .chanset # [+|-]phrase - |    
#####################################################################################
#
#	25.08.2008
#	v0.1 Edit by adium
#	-    .
#
#####################################################################################

package require http 2.7

namespace eval phrase {
	variable author			"adium@RusNet"
	variable version		"0.1"
	variable date			"11-Sep-2008"
	variable unamespace		[namespace tail [namespace current]]
	variable chflag			$unamespace
	variable pause			20
	variable msgspeed		2
	setudef flag			$chflag
	if {![info exists egglib(ver)]} {
		setudef flag		usecolors
	}
	variable prefix			"!"
	variable flags			"n|n"
	variable binds			[list "phrase" ""]
	foreach b $binds {
		bind pub ${flags} "${prefix}${b}" [namespace current]::main
	}
	bind pub ${flags} "${prefix}phr" [namespace current]::main2
	proc main {nick uhost hand chan text} {
		variable chflag
		if {![channel get $chan $chflag]} { return 0 }
		variable prefix; variable msgspeed
		if {[checkflood $nick $uhost [namespace tail [lindex [info lev 0] 0]]]} {
			output $nick [subst {\00314    \00306${prefix}phrase\00314.  \00306[timewait $nick $uhost [namespace tail [lindex [info lev 0] 0]]] .\00314   ...\003}] -speed $msgspeed -type ntc
			return 0
		}
		::http::config -useragent "Mozilla/5.0 (X11; U; Linux i686; ru-RU; rv:1.8.1) Gecko/2006101023 Firefox/2.0"
		set url [::http::geturl "http://icmp.ru/phraser/" -timeout 15000]
		set html [::http::data $url]
		::http::cleanup $url
		regsub -all -- (\t|\n) $html "" html
		set html [string trim $html]
		regexp -- {<br><b>(.*?)</b><br>(.*?)<br>} $html -> str2 str1
		output $chan [subst {\00310$nick\00304: \00306$str1 \00313\[\00314$str2\00313\]\003}] -speed $msgspeed -type msg
	}
	proc main2 {nick uhost hand chan text} {
		variable chflag
		if {![channel get $chan $chflag]} { return 0 }
		variable prefix; variable msgspeed
		if {[checkflood $nick $uhost [namespace tail [lindex [info lev 0] 0]]]} {
			output $nick [subst {\00314    \00306${prefix}phr\00314.  \00306[timewait $nick $uhost [namespace tail [lindex [info lev 0] 0]]] .\00314   ...\003}] -speed $msgspeed -type ntc
			return 0
		}
		::http::config -useragent "Mozilla/5.0 (X11; U; Linux i686; ru-RU; rv:1.8.1) Gecko/2006101023 Firefox/2.0"
		set url [::http::geturl "http://icmp.ru/phraser/" -timeout 15000]
		set html [::http::data $url]
		::http::cleanup $url
		regsub -all -- (\t|\n) $html "" html
		set html [string trim $html]
		regexp -- {<meta http-equiv="Content-Type" content="text/html;charset=koi8-r">(.*?)</td>} $html -> str
		output $chan [subst {\00310$nick\00304: \00306$str\003}] -speed $msgspeed -type msg
	}
	proc checkflood {nick uhost comm} {
		variable pause; variable lastcall; variable prefix
		if {[matchattr $nick n] || [matchattr $nick m] || [matchattr $nick o]} { return 0 } else {
			if {[info exists lastcall($comm,$uhost)]} {
				if {[expr [expr [unixtime] - $lastcall($comm,$uhost)] < $pause]} {
					set det [expr [unixtime] - $lastcall($comm,$uhost)]
					set wtime [expr $pause - $det]
					return 1
				}
			}
		}
		set lastcall($comm,$uhost) [unixtime]
		return 0
	}
	proc timewait {nick uhost comm} {
		variable pause; variable lastcall; return [expr { $lastcall($comm,$uhost) + $pause - [unixtime] }]
	}
	proc output {c s args} {
		importvars [list] $args [list speed 2 type msg]
		if {[string index $c 0] eq "#"} {
			if {![channel get $c usecolors]} { set s [stripcodes cbur $s] }
		}
		if {[string tolower $type] eq "msg"} {
			set t "PRIVMSG"
		} elseif {[string tolower $type] eq "ntc"} {
			set t "NOTICE"
		} else {
			return -code error "wrong args: should be \"[namespace current]::output chan string -speed NUM -type NAME\""
		}
		if {[regexp -- {\d+} $speed]} {
			if {$speed == "0"} {
				set msg [string range $s 0 end]
				append msg "\n"
				putdccraw 0 [string length $msg] $msg
			} elseif {$speed == "1"} {
				putquick "$t $c :$s"
			} elseif {$speed == "2"} {
				putserv "$t $c :$s"
			} elseif {$speed == "3"} {
				puthelp "$t $c :$s"
			} else { return -code error "wrong args: should be \"[namespace current]::output chan string -speed NUM -type NAME\"" }
		}
	}
	proc importvars {lo {la {}} {ln {}}} {
		set lvars [list]
		foreach {var value} $ln {uplevel [list set $var $value]; lappend lvars $var}
		foreach {flag value} $la {
			if {[string index $flag 0] == "-"} {
				set var [string range $flag 1 end]
				uplevel [list set $var $value]
				lappend lvars $var
			}
		}
		foreach var $lo {
			if {[lsearch $lvars $var] < 0} {
				set value [uplevel 2 "if {\[info exists $var\]} {set $var} else {set $var \"\"}"]
				uplevel [list set $var $value]
			}
		}
	}
	putlog "[namespace current]:: v$version \[$date\] by $author loaded."
}